<?php
/*
Plugin Name: Blogger Title Fix
Plugin URI: http://notions.okuda.ca/wordpress-plugins/blogger-title-fix/
Description: Replaces numerical titles (from Blogger import) with the first few words of the post.
Author: Poco
Version: 0.1
Author URI: http://notions.okuda.ca
*/


class ko_blogger_title_fix
{

	function fragment($str, $n, $delim='...')
	{
		$len = strlen($str);
		if ($len > $n)
		{
			// This code would limit the output to about n characters and not cut any words.
			// This looks a bit better than the default, but this is not how Blogger reacts.
			//preg_match('/(.{' . $n . '}.*?)\b/', $str, $matches);
			//return rtrim($matches[1]) . $delim;

			// Just take the first n characters, like Blogger does.
			return substr(trim($str), 0, $n) . $delim;
		}
		else
		{
			return $str;
		}
	}

	function is_bad_title($title)
	{
		// Look for a title that is only decimal digits (or empty)
		return preg_match("/^\d*$/", $title);
	}

	function filter_title($content = '', $thispost = NULL)
	{
		global $post;

		// If we didn't get a post parameter then use the global one.
		if (!isset($thispost))
		{
			$thispost = post;
		}
		else
		{
			// In generate $thispost will only contain the ID and Title and we need more
			// So get it now.
			$thispost = get_post($thispost->ID);
		}

		if ($this->is_bad_title($content))
		{
			// Couldn't think of a better way to handle this.
			// Stole this code from get_the_excerpt except that it uses the available $thispost
			// instead of the global $post.
			$output = $thispost->post_excerpt;
			if ( !empty($thispost->post_password) ) { // if there's a password
				if ( $_COOKIE['wp-postpass_'.COOKIEHASH] != $thispost->post_password ) {  // and it doesn't match the cookie
					$output = "";  // empty title
				}
			}

			// If there is no excerpt then we take the content.  Again, there was no good function to call
			// here since they all assume $post is global.
			if ( '' == $output ) {
				$output = $thispost->post_content;
				$output = apply_filters('the_content', $output);
				$output = str_replace(']]>', ']]&gt;', $output);
				$output = strip_tags($output);
			}


			$newtitle = $this->fragment($output, 48, '...');
			return $newtitle;
		}
		else
		{
			return $content;
		}
	}
}

$ko_blogger_title_fix_instance = new ko_blogger_title_fix();
add_filter('the_title', array(&$ko_blogger_title_fix_instance, 'filter_title'),10,2);

?>
